﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    internal class DrawingAirbus : DrawningAirplane
    {
        public DrawingAirbus(int speed, float weight, Color bodyColor, Color dopColor, bool compartment, bool engine) :
        base(speed, weight, bodyColor, 150, 30)
        {
            airplane = new EntityAirbus(speed, weight, bodyColor, dopColor, compartment, engine);
        }

        public override void DrawTransport(Graphics g)
        {
            if (airplane is not EntityAirbus grandAirbus)
            {
                return;
            }

            Pen pen = new(Color.Black, 2);
            Brush dopBrush = new SolidBrush(grandAirbus.DopColor);
            if (grandAirbus.Engine)
            {
                g.FillRectangle(dopBrush, _startPosX , _startPosY + 12 + _airplaneWidth / 10, 10, 10);    
                g.FillRectangle(dopBrush, _startPosX, _startPosY + 12 + _airplaneWidth / 5, 10, 10);
                
            }

            _startPosX += 10;
            base.DrawTransport(g);
            _startPosX -= 10;

            if (grandAirbus.Compartment)
            {
                g.FillRectangle(dopBrush, _startPosX + 85, _startPosY + 10, 50, 15);
                g.DrawPolygon(pen, new[]
            {
                new Point((int)(_startPosX + 85), (int)(_startPosY + 10)),
                new Point((int)(_startPosX + 85), (int)(_startPosY + 25)),
                new Point((int)(_startPosX + 60), (int)(_startPosY + 25)),
                new Point((int)(_startPosX + 85), (int)(_startPosY + 10)),
            });
            }

        }
    }
}
